'use strict';

var _reactTransformCatchErrors2 = require('react-transform-catch-errors');

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

var _reactTransformCatchErrors3 = _interopRequireDefault(_reactTransformCatchErrors2);

var _react = require('react');

var _redboxReact = require('redbox-react');

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

exports.__esModule = true;

var _react2 = _interopRequireDefault(_react);

// we create redux here and store it within this component
// call onRedux on redux creation
var _components = {
	_$Unknown: {
		isInFunction: true
	}
};

var _reactComponentWrapper = _reactTransformCatchErrors3['default']({
	filename: 'src/highOrderComponents/ReduxHolder.js',
	components: _components,
	locals: [],
	imports: [_react, _redboxReact]
});

function _wrapComponent(uniqueId) {
	return function (ReactClass) {
		return _reactComponentWrapper(ReactClass, uniqueId);
	};
}

exports['default'] = function (createReduxFunc, ReduxComponent) {
	return (function (_Component) {
		_inherits(_class, _Component);

		function _class(props, context) {
			_classCallCheck(this, _class2);

			_Component.call(this, props, context);
			this.state = {};
		}

		_class.prototype.componentDidMount = function componentDidMount() {
			var reduxOptions = this.props.reduxOptions ? this.props.reduxOptions : {};
			var store = createReduxFunc(reduxOptions);

			this.setState({ store: store });

			if (this.props.onRedux) {
				this.props.onRedux(store);
			}
		};

		_class.prototype.render = function render() {
			if (!this.state.store) {
				return _react2['default'].createElement('div', null);
			}

			return _react2['default'].createElement(ReduxComponent, { store: this.state.store });
		};

		var _class2 = _class;
		_class = _wrapComponent('_$Unknown')(_class) || _class;
		return _class;
	})(_react.Component);
};

module.exports = exports['default'];