'use strict';

var _reactTransformCatchErrors2 = require('react-transform-catch-errors');

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

var _reactTransformCatchErrors3 = _interopRequireDefault(_reactTransformCatchErrors2);

var _react = require('react');

var _redboxReact = require('redbox-react');

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

exports.__esModule = true;

var _react2 = _interopRequireDefault(_react);

var _ramda = require('ramda');

var _ramda2 = _interopRequireDefault(_ramda);

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _deepDiff = require('deep-diff');

var _share = require('../share');

var _reduxActions = require('redux-actions');

var _components = {
	_$Unknown: {
		isInFunction: true
	}
};

var _reactComponentWrapper = _reactTransformCatchErrors3['default']({
	filename: 'src/highOrderComponents/ReduxOptions.js',
	components: _components,
	locals: [],
	imports: [_react, _redboxReact]
});

function _wrapComponent(uniqueId) {
	return function (ReactClass) {
		return _reactComponentWrapper(ReactClass, uniqueId);
	};
}

var _newOptions = _ramda2['default'].curry(function (changedPropKeyAcMap, obj) {
	return function (dispatch, getState) {
		var newOptions = _immutable2['default'].fromJS(obj);

		var _getState = getState();

		var options = _getState.options;

		dispatch(_reduxActions.createAction('@@@REDUX_COMPONENT_NEW_OPTIONS')(obj));
		_share.dispatchOnNewProps(dispatch, changedPropKeyAcMap, options, newOptions);
	};
});

var notFunction = function notFunction(item) {
	return typeof item != "function";
};
var getNoFunctionsObject = _ramda2['default'].pickBy(notFunction);

var subscribeWithState = function subscribeWithState(redux, cb) {
	return redux.subscribe(function () {
		return cb(redux.getState());
	});
};

var onReduxSubscribe = _ramda2['default'].curry(function (options, callbacksSelectorsMap, reduxState) {
	_ramda2['default'].compose(_ramda2['default'].forEach(function (_ref) {
		var callbackName = _ref[0];
		var selector = _ref[1];

		if (!options || !callbackName || !options[callbackName] || !selector) {
			return;
		}
		options[callbackName](selector(reduxState));
	}), _ramda2['default'].toPairs)(callbacksSelectorsMap);
});

// decorator to provide react component api for redux component

exports['default'] = function (callbacksSelectorsMap, changedPropKeyAcMap, methodsMap, reduxOptions, ReduxComponent) {
	return (function (_Component) {
		_inherits(_class, _Component);

		function _class(props, context) {
			_classCallCheck(this, _class2);

			_Component.call(this, props, context);
			this.state = {
				pendingProps: null,
				redux: null,
				unSubscribe: null
			};
		}

		_class.prototype.componentDidMount = function componentDidMount() {
			this.newOptions(this.props);
		};

		_class.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
			this.newOptions(nextProps);
		};

		_class.prototype.componentWillUnmount = function componentWillUnmount() {
			if (this.state.unSubscribe) {
				this.state.unSubscribe();
			}
		};

		_class.prototype.dispatchPendingProps = function dispatchPendingProps() {
			if (this.state.redux && this.state.pendingProps) {
				this.newOptions(this.state.pendingProps);
				this.setState({
					pendingProps: null
				});
			}
		};

		_class.prototype.onRedux = function onRedux(redux) {
			var _this = this;

			var unSubscribe = subscribeWithState(redux, onReduxSubscribe(this.props, callbacksSelectorsMap));

			this.setState({
				redux: redux,
				unSubscribe: unSubscribe
			}, function () {
				return _this.dispatchPendingProps();
			});

			_ramda2['default'].compose(_ramda2['default'].forEach(function (_ref2) {
				var name = _ref2[0];
				var method = _ref2[1];

				_this[name] = function () {
					for (var _len = arguments.length, params = Array(_len), _key = 0; _key < _len; _key++) {
						params[_key] = arguments[_key];
					}

					redux.dispatch(method.apply(null, params));
				};
			}), _ramda2['default'].toPairs)(methodsMap);

			if (this.props.onRedux) {
				this.props.onRedux(redux);
			}
		};

		_class.prototype.newOptions = function newOptions(options) {
			var _this2 = this;

			var nextPropsNoFunctions = getNoFunctionsObject(options);

			if (!this.state.redux) {
				this.setState({
					pendingProps: nextPropsNoFunctions
				}, function () {
					return _this2.dispatchPendingProps();
				});
				return;
			}

			this.state.redux.dispatch(_newOptions(changedPropKeyAcMap)(nextPropsNoFunctions));
		};

		_class.prototype.render = function render() {
			return _react2['default'].createElement(ReduxComponent, {
				reduxOptions: reduxOptions,
				onRedux: this.onRedux.bind(this) });
		};

		var _class2 = _class;
		_class = _wrapComponent('_$Unknown')(_class) || _class;
		return _class;
	})(_react.Component);
};

module.exports = exports['default'];