'use strict';

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _ramda = require('ramda');

var _ramda2 = _interopRequireDefault(_ramda);

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _deepDiff = require('deep-diff');

var deepDiffToList = _ramda2['default'].map(function (item) {
	return item.path[0];
});

var check = _ramda2['default'].curry(function (eqFunc, diffFunc, oldProps, newProps, onChange) {
	if (!oldProps) {
		onChange(oldProps, newProps, null);
	}

	if (eqFunc(oldProps, newProps)) {
		return;
	}

	var calcedDiff = diffFunc(oldProps, newProps);

	onChange(oldProps, newProps, calcedDiff);
});

var checkIm = check(_immutable2['default'].is, function (a, b) {
	return _deepDiff.diff(a.toJS(), b.toJS());
});

var processChange = _ramda2['default'].curry(function (getArrayOfChangedProps, oldProps, newProps, calcedDiff, onNewPropValue) {
	return _ramda2['default'].compose(_ramda2['default'].forEach(function (changedPropKey) {
		var value = newProps.get(changedPropKey);
		onNewPropValue({ key: changedPropKey, value: value });
	}), getArrayOfChangedProps)(calcedDiff);
});

var deepDiffProcessChange = processChange(deepDiffToList);

var dispatchOnNewProps = function dispatchOnNewProps(dispatch, changedPropKeyAcMap, oldProps, newProps) {
	var arrayToCall = [];
	checkIm(oldProps, newProps, function (oldProps, newProps, calcedDiff) {
		deepDiffProcessChange(oldProps, newProps, calcedDiff, function (_ref) {
			var key = _ref.key;
			var value = _ref.value;

			var defaultAc = changedPropKeyAcMap['@default'];
			var acToCall = changedPropKeyAcMap[key] ? changedPropKeyAcMap[key] : defaultAc;
			arrayToCall.push({
				acToCall: acToCall,
				value: value,
				key: changedPropKeyAcMap[key] ? key : '@default'
			});
		});
	});

	_ramda2['default'].compose(_ramda2['default'].forEach(function (_ref2) {
		var acToCall = _ref2.acToCall;
		var value = _ref2.value;
		var key = _ref2.key;

		dispatch(acToCall(value));
	}), _ramda2['default'].uniqBy(function (_ref3) {
		var key = _ref3.key;
		return key;
	}))(arrayToCall);
};

exports.dispatchOnNewProps = dispatchOnNewProps;
var prependUpdateFunc = _ramda2['default'].curry(function (updateFuncMap, acMap) {
	return _ramda2['default'].mapObjIndexed(function (num, key, obj) {
		if (!updateFuncMap[key]) {
			return acMap[key];
		}

		return function (val) {
			return acMap[key](updateFuncMap[key](val));
		};
	}, acMap);
});
exports.prependUpdateFunc = prependUpdateFunc;